﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#If Author
B4XSignature
Author: Omar Parra A.
Version: 1.0
#End If

#if Depends
Version=1.0
B4J.DependsOn=jXUI
B4A.DependsOn=XUI
B4i.DependsOn=iXUI
#End If

#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Signature Background Color
#DesignerProperty: Key: StrokeColor, DisplayName: Stroke Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Stroke Color Line
#DesignerProperty: Key: StrokeWidth, DisplayName: Stroke Size, FieldType: Float, DefaultValue: 2, Description: Stroke Width Line

#Region Designer

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private mLbl As B4XView 'ignore
	Private xui As XUI 'ignore

	Private signature As B4XView
	Private cvs As B4XCanvas
	
	Private BackgroundColor As Int
	Private StrokeWidth As Float
	Private StrokeColor As Int
	Private LastX, LastY As Float
	
	Private TitleText As String
	Private TitleColor As Int
	Private TitleSize As B4XFont

	Private IsDrawSignature As Boolean
	Private IsTitleSignature As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	signature = xui.CreatePanel("Signature")
	IsDrawSignature = False
	IsTitleSignature = False
End Sub

'Base type must be Object.
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mLbl = Lbl
	
	BackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	StrokeColor = xui.PaintOrColorToColor(Props.Get("StrokeColor"))
	StrokeWidth = DipToCurrent(Props.Get("StrokeWidth"))
	
	mBase.AddView(signature, 0, 0, mBase.Width, mBase.Height)
	cvs.Initialize(signature)

	#if B4A or B4I
	Base_Resize(mBase.Width, mBase.Height)
	#end If	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	signature.SetLayoutAnimated(0, 0, 0, Width, Height)
	cvs.Resize(Width, Height)
	Clear
End Sub

#End Region

#Region Fuctions

Private Sub Signature_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case signature.TOUCH_ACTION_DOWN
			LastX = X
			LastY = Y
		Case signature.TOUCH_ACTION_MOVE
			cvs.DrawLine(LastX, LastY, X, Y, StrokeColor, StrokeWidth)
			cvs.DrawCircle (x, y, StrokeWidth/2, StrokeColor,  True, StrokeWidth/2)
			cvs.Invalidate
			LastX = X
			LastY = Y
			IsDrawSignature = True
	End Select
End Sub

'Get true or false if there is a signature.
Public Sub getIsSignature As Boolean
	Return IsDrawSignature
End Sub

'Gets or sets the background color.
'Default: White
Public Sub getColor As Int
	Return BackgroundColor
End Sub

Public Sub setColor(Color As Int)
	BackgroundColor = Color
	Clear
End Sub

'Set the color and size of the signature stroke.
'Deafult:
'Color = Black
'Size = 2
Public Sub Stroke(Color As Int, Size As Float)
	StrokeColor = Color
	StrokeWidth = DipToCurrent(Size)
End Sub

'Set the text, color and size of the title.
Public Sub Title(Text As String, Color As Int, Size As Float, Bold As Boolean)
	TitleText = Text
	TitleColor = Color
	TitleSize = xui.CreateDefaultFont(Size)
	If Bold Then TitleSize = xui.CreateDefaultBoldFont(Size)
	IsTitleSignature = True
End Sub

'Clear the signature.
Public Sub Clear
	cvs.DrawRect(cvs.TargetRect, BackgroundColor, True, 0)
	cvs.Invalidate
	IsDrawSignature = False
End Sub

'Get bitmap the signature.
Public Sub Bitmap As B4XBitmap
	If IsTitleSignature Then
		Dim r As B4XRect = cvs.MeasureText("M", TitleSize)
		Dim Baseline As Int = cvs.TargetRect.Bottom - r.Height - r.Top - 4dip
		cvs.DrawText(TitleText, 6dip, Baseline, TitleSize, TitleColor, "LEFT")
		cvs.Invalidate
	End If
	Dim b As B4XBitmap = cvs.CreateBitmap.Crop(0, 0, cvs.TargetRect.Width, cvs.TargetRect.Height)
	Return b.Crop(0, 0, cvs.TargetRect.Width, cvs.TargetRect.Height)
End Sub

#End Region
